#!/bin/bash

set -e

exec 0< defs.h
while
  read DEFINE NAME VALUE
do
  if test "$DEFINE" == "#define"
  then
    eval $NAME=$VALUE
  fi
done
unset DEFINE
unset LINE
unset VALUE

exec 3>&1
exec > "output/$1.sh"
exec 0< "$1"
IFS=
while
  read -r LINE
do
  if test "${LINE:0:1}" == "#"
  then
    echo "${LINE:1}"
  else
    LINE="${LINE//\\/\\\\}"
    LINE="${LINE//\"/\\\"}"
    echo "echo \"$LINE\""
  fi
done
exec 1>&-
exec 1>&3

chmod 700 "output/$1.sh"
. "output/$1.sh"
